#pragma once

#include "CoreMinimal.h"
#include "GameManualViewInterface.h"
#include "CoreBaseUserWidget.h"
#include "EGameManualMenuState.h"
#include "EHelpType.h"
#include "OnSetOnboardingMenuSubtitleDelegate.h"
#include "OnResetOnboardingMenuSubtitleDelegate.h"
#include "CoreGameManualPanelWidget.generated.h"

class UPanelWidget;
class UCoreGameManualCategoryButton;
class UCoreTabContainerWidget;
class UDBDTextBlock;
class UDBDRichTextBlock;
class UCoreSelectableButtonWidget;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIVIEWSCORE_API UCoreGameManualPanelWidget : public UCoreBaseUserWidget, public IGameManualViewInterface
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EGameManualMenuState _currentSelectedManualMenu;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EHelpType _currentGameManualTopic;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UPanelWidget* CategoryPanel;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreGameManualCategoryButton* GameCategoryButton;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreGameManualCategoryButton* SurvivorCategoryButton;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreGameManualCategoryButton* KillerCategoryButton;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UPanelWidget* TopicsPanel;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreTabContainerWidget* GameManualTopicsTabs;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDTextBlock* GameManualContentTitle;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDTextBlock* GameManualContentSubtitle;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDRichTextBlock* GameManualContentText;

private:
	UPROPERTY(BlueprintReadWrite, BlueprintAssignable, meta=(AllowPrivateAccess=true))
	FOnSetOnboardingMenuSubtitleDelegate _onSetOnboardingMenuSubtitleDelegate;

	UPROPERTY(BlueprintReadWrite, BlueprintAssignable, meta=(AllowPrivateAccess=true))
	FOnResetOnboardingMenuSubtitleDelegate _onResetOnboardingMenuSubtitleDelegate;

private:
	UFUNCTION(BlueprintCallable)
	void ToggleGameManualMenuState();

	UFUNCTION(BlueprintCallable)
	void ShowHelpTopics(EHelpType categoryType);

	UFUNCTION(BlueprintCallable)
	void SetGameManualMenuState(EGameManualMenuState menuState);

	UFUNCTION(BlueprintCallable)
	void SetCurrentOnbardingMenuSubtitle();

public:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void ResetScrolls(bool resetTopicsScroll);

private:
	UFUNCTION(BlueprintCallable)
	void OnTopicsTabSelected(UCoreSelectableButtonWidget* selectedButton);

public:
	UCoreGameManualPanelWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreGameManualPanelWidget) { return 0; }
